﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.DragDrop;

namespace WpfApplication11
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public static ObservableCollection<ApplicationInfo> GenerateApplicationInfos()
        {
            ObservableCollection<ApplicationInfo> result = new ObservableCollection<ApplicationInfo>();

            ApplicationInfo info1 = new ApplicationInfo();
            info1.Name = "James Collider";
            info1.Author = "Rockford";
            info1.Details = new ObservableCollection<ApplicationDetail>(from c in Enumerable.Range(0, 10) select new ApplicationDetail { Description = "Some Description", ID = c });

            result.Add(info1);

            ApplicationInfo info2 = new ApplicationInfo();
            info2.Name = "Alentra";
            info2.Author = "Google.";
            info2.Details = new ObservableCollection<ApplicationDetail>(from c in Enumerable.Range(0, 10) select new ApplicationDetail { Description = "Some Description", ID = c });

            result.Add(info2);

            ApplicationInfo info3 = new ApplicationInfo();
            info3.Name = "Thomas COOK";
            info3.Author = "Yahoo";
            info3.Details = new ObservableCollection<ApplicationDetail>(from c in Enumerable.Range(0, 10) select new ApplicationDetail { Description = "Some Description", ID = c });

            result.Add(info3);

            ApplicationInfo info4 = new ApplicationInfo();
            info4.Name = "Britsh Airways";
            info4.Author = "Google";
            info4.Details = new ObservableCollection<ApplicationDetail>(from c in Enumerable.Range(0, 10) select new ApplicationDetail { Description = "Some Description", ID = c });


            ApplicationInfo info5 = new ApplicationInfo();
            info5.Name = "Trader Joe";
            info5.Author = "Factory";
            info5.Details = new ObservableCollection<ApplicationDetail>(from c in Enumerable.Range(0, 10) select new ApplicationDetail { Description = "Some Description", ID = c });


            ApplicationInfo info6 = new ApplicationInfo();
            info6.Name = "IE Fox";
            info6.Author = "Open Org";
            info6.Details = new ObservableCollection<ApplicationDetail>(from c in Enumerable.Range(0, 10) select new ApplicationDetail { Description = "Some Description", ID = c });

            result.Add(info6);

            ApplicationInfo info7 = new ApplicationInfo();
            info7.Name = "Charting";
            info7.Author = "PieChart";
            info7.Details = new ObservableCollection<ApplicationDetail>(from c in Enumerable.Range(0, 10) select new ApplicationDetail { Description = "Some Description", ID = c });

            result.Add(info7);

            ApplicationInfo info8 = new ApplicationInfo();
            info8.Name = "Batman";
            info8.Author = "Games";
            info8.Details = new ObservableCollection<ApplicationDetail>(from c in Enumerable.Range(0, 10) select new ApplicationDetail { Description = "Some Description", ID = c });

            result.Add(info8);

            return result;
        }

        ObservableCollection<ApplicationInfo> allApplications = GenerateApplicationInfos();
        ObservableCollection<ApplicationInfo> myApplications;
        Brush listBoxDragPossible = new SolidColorBrush(Colors.Orange);

        public MainWindow()
        {

            InitializeComponent();
            myApplications = new ObservableCollection<ApplicationInfo>();
            allApplicationsBox.ItemsSource = allApplications;
            myApplicationsBox.ItemsSource = myApplications;

            RadDragAndDropManager.AddDragQueryHandler(this, OnDragQuery);
            RadDragAndDropManager.AddDragInfoHandler(this, OnDragInfo);
            RadDragAndDropManager.AddDropQueryHandler(this, OnDropQuery);
            RadDragAndDropManager.AddDropInfoHandler(this, OnDropInfo);
        }

        private void OnDropInfo(object sender, DragDropEventArgs e)
        {
            ItemsControl box = e.Options.Destination as ItemsControl;
            if (box == null) return;
            IList<ApplicationInfo> itemsSource = box.ItemsSource as IList<ApplicationInfo>;
            ApplicationInfo payload = e.Options.Payload as ApplicationInfo;

            if (e.Options.Status == DragStatus.DropPossible)
            {
                box.BorderBrush = listBoxDragPossible;
            }
            else
            {
                box.BorderBrush = new SolidColorBrush(Colors.Gray);
            }

            if (e.Options.Status == DragStatus.DropComplete)
            {
                if (!itemsSource.Contains(payload))
                {
                    itemsSource.Add(payload);
                }
            }
        }

        void OnDropQuery(object sender, DragDropQueryEventArgs e)
        {

            ItemsControl box = e.Options.Destination as ItemsControl;
            if (box == null) return;
            IList<ApplicationInfo> itemsSource = box.ItemsSource as IList<ApplicationInfo>;
            ApplicationInfo payload = e.Options.Payload as ApplicationInfo;

            e.QueryResult = payload != null && !itemsSource.Contains(payload);
        }

        void OnDragInfo(object sender, DragDropEventArgs e)
        {
            if (!(e.Options.Source is ListBoxItem))
                return;

            try
            {
                ListBoxItem listBoxItem = e.Options.Source as ListBoxItem;
                ListBox box = ItemsControl.ItemsControlFromItemContainer(listBoxItem) as ListBox;
                IList<ApplicationInfo> itemsSource = box.ItemsSource as IList<ApplicationInfo>;
                ApplicationInfo payload = e.Options.Payload as ApplicationInfo;

                if (e.Options.Status == DragStatus.DragComplete)
                {
                    if (payload != null && itemsSource.Contains(payload))
                    {
                        itemsSource.Remove(payload);
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        protected virtual void OnDragQuery(object sender, DragDropQueryEventArgs e)
        {
            ListBoxItem listBoxItem = e.Options.Source as ListBoxItem;
            ListBox box = ItemsControl.ItemsControlFromItemContainer(listBoxItem) as ListBox;

            if (e.Options.Status == DragStatus.DragQuery && box != null)
            {
                e.Options.Payload = box.SelectedItem;
                ContentControl cue = new ContentControl();
                cue.ContentTemplate = this.Resources["ApplicationDragTemplate"] as DataTemplate;
                cue.Content = box.SelectedItem;
                e.Options.DragCue = cue;
                e.Options.ArrowCue = RadDragAndDropManager.GenerateArrowCue();
            }

            e.QueryResult = true;
        }
    }

    public class ApplicationInfo
    {
        // private Double _price;
        private String _name;
        private String _author;





        public String Name
        {
            get { return this._name; }
            set { this._name = value; }
        }

        public String Author
        {
            get { return this._author; }
            set { this._author = value; }
        }

        public ObservableCollection<ApplicationDetail> Details { get; set; }
    }

    public class ApplicationDetail
    {
        public int ID { get; set; }
        public string Description { get; set; }
    }

}
